#ifndef Fl_Chart3d_H
#define Fl_Chart3d_H

#include <FL/Fl_Widget.H>

class FL_EXPORT Fl_Chart3d : public Fl_Widget {
public:
 Fl_Chart3d(int X, int Y, int W, int H, const char*L=0);
 ~Fl_Chart3d();
 
 void draw();
 
 // for manage slices (labels and values)
 const int count_slices();
 bool set_size(int ns);
 void set_slice(double val, Fl_Color col, const char* txt, char detach=0, int index = -1); // -1 - to end of list slices
 double get_value(int index);
 Fl_Color get_color(int index);
 char get_detach(int index);
 const char* get_text(int index) const;
 
private:
 int sz_; // size of txt_/val_/col_/detach_ arrays
 char **txt_; // labels
 double *val_; // values
 Fl_Color *col_; // colors
 char *detach_; // is detached slice ?
};

#endif // Fl_Chart3d_H
