#ifndef Fl_Chart3d_cxx
#define Fl_Chart3d_cxx

#include "Fl_Chart3d.H"

#include <FL/Fl.H>
#include <FL/fl_draw.H>
#include <math.h>
// // #include <time.h>
// // #include <sys/time.h>
// // #include <unistd.h>
// // 
// // 
// // double GetTimeSec(){
// // 
// // #ifdef _WIN32
// // return ((unsigned(UtcTimeStamp()))+double(GetTickCount())/1000.0);
// // #else
// // struct timeval c;
// // gettimeofday(&c, NULL);
// // return ((unsigned)c.tv_sec + double(c.tv_usec)/1000000.0);
// // #endif
// // 
// // } /// end function `GetTimeSec'

#define M_PI_DIV_180 0.017453292519943296


Fl_Chart3d::Fl_Chart3d (int X, int Y, int W, int H, const char*L)
 :Fl_Widget(X,Y,W,H,L),
 sz_(0),txt_(0),val_(0),col_(0),detach_(0) {
 
}


Fl_Chart3d::~Fl_Chart3d () { set_size(0); }


const int Fl_Chart3d::count_slices () { return sz_; }





double Fl_Chart3d::get_value (int index) {
 return (index>=0&&index<sz_) ? val_[index]: 0.0;
}



const char* Fl_Chart3d::get_text (int index) const {
 return (index>=0&&index<sz_) ? txt_[index]: "";
}



Fl_Color Fl_Chart3d::get_color (int index) {
 return (index>=0&&index<sz_) ? col_[index]: color();
}



char Fl_Chart3d::get_detach (int index) {
 return (index>=0&&index<sz_) ? detach_[index]: 0;
}




bool Fl_Chart3d::set_size (int ns) {
 if (ns <= 0) {
  if (sz_ <= 0) { return true; }
  delete[] val_; val_ = 0;
  delete[] col_; col_ = 0;
  delete[] detach_; detach_ = 0;
  for (int _i = 0; _i < sz_; _i++) {
   if (txt_[_i]) { delete[] txt_[_i]; txt_[_i] = 0; }
  }
  delete[] txt_; txt_ = 0; sz_ = 0;
  return true;
 }
 
 char ** new_txt = 0;
 double* new_val = 0;
 Fl_Color* new_col = 0;
 char* new_detach = 0;
 
 if ((new_val = new double [ns])) {
  if (!(new_col = new Fl_Color[ns])) {
   delete[] new_val; new_val = 0;
   return false;
  }
  if (!(new_detach = new char[ns])) {
   delete[] new_val; new_val = 0;
   delete[] new_col; new_col = 0;
   return false;
  }
  if ((new_txt = new char *[ns])) {
   for (int _i = 0; _i < ns; _i++) {
    if (_i < sz_) {
     new_txt[_i] = txt_[_i]; txt_[_i] = 0;
     new_val[_i] = val_[_i];
     new_col[_i] = col_[_i];
     new_detach[_i] = detach_[_i];
    } else if (!(new_txt[_i] = new char[64])) {
     for (int _i = 0; _i < ns; _i++) {
      if (new_txt[_i]) { delete[] new_txt[_i]; new_txt[_i] = 0; }
     } delete[] new_txt; new_txt = 0;
     for (int _i = 0; _i < sz_; _i++) {
      if (txt_[_i]) { delete[] txt_[_i]; txt_[_i] = 0; }
     } delete[] txt_; txt_ = 0; sz_ = 0;
     delete[] new_val; new_val = 0;
     delete[] val_; val_ = 0;
     delete[] new_col; new_col = 0;
     delete[] col_; col_ = 0;
     delete[] new_detach; new_detach = 0;
     delete[] detach_; detach_ = 0;
     return false;
    } else { memset(new_txt[_i], 0, 64); new_val[_i] = 0.0; new_col[_i] = color(); new_detach[_i] = 0; }
   }
   for (int _i = 0; _i < sz_; _i++) {
    if (txt_[_i]) { delete[] txt_[_i]; txt_[_i] = 0; }
   } delete[] txt_; txt_ = 0;
   delete[] val_; val_ = 0; delete[] col_; col_ = 0; delete[] detach_; detach_ = 0;
   txt_ = new_txt; val_ = new_val; col_ = new_col; detach_ = new_detach; sz_ = ns;
   return true;
  } else { delete[] new_val; new_val = 0; delete[] new_col; new_col = 0; delete[] new_detach; new_detach = 0; }
 }
 return false;
}






void Fl_Chart3d::set_slice (double val, Fl_Color col, const char* txt, char detach, int index) {
 if (!txt || !*txt) { return; }
 if (index < 0) {
  if (!set_size(sz_+1)) { return; }
  index = sz_-1;
 } else if (index > sz_){
  if (!set_size(index+1)) { return; }
 }
 
 if (strlen(txt) >= 64) {
  delete[] txt_[index]; txt_[index] = 0;
  if (!(txt_[index] = new char[strlen(txt)+1])) { return; }
 }
 
 strcpy(txt_[index], txt);
 val_[index] = val;
 col_[index] = col;
 detach_[index] = detach;
}






void Fl_Chart3d::draw () {
 
 fl_push_clip(x(),y(),w(),h());
 
 ///double start_draw = GetTimeSec();
 
 fl_color(active_r() ? color() : fl_inactive(color()));
 fl_rectf(x(),y(),w(),h());
 
 volatile int heightE=20; // height of slice
 float step = 0.5f;
 
 float *start_angle=0;
 float *end_angle=0;
 float offset_angle = -60;
 
 
 
 volatile int CX, CY, W1, H1, w1, h1;
 int Sx = 0, Sy = 0, Ex = 0, Ey = 0, sx = 0, sy = 0, ex = 0, ey = 0;
 
 float X1, Y1, x1, y1;
 float lX1=0.0,lY1=0.0,lx1=0.0,ly1=0.0;
 
 Fl_Color col_sides, col_iring, col_ering, col_top, col_border;
 
 
 if (!(start_angle = new float[sz_]) || !(end_angle = new float[sz_])) { goto LABEL_EXIT; }
 
 
 W1 = (w()<h()) ? w() : h() - 100;
 H1 = W1-W1/3;
 
 W1 /= 2;
 H1 /= 2;
 
 w1 = W1/3;
 h1 = H1/3;
 
 CX = x()+w()/2;//-W1/2;
 CY = y()+h()/2;//-H1/2;
 
 
 if (!sz_) {
  // there are no datas, draw only skeleton and exit !
  
  step = 0.1;
  col_border = fl_color_average(color(), FL_BLACK, 0.88);
  fl_color(col_border);
  
  fl_begin_points();
  for (float angle = -90.0; angle < 270.0+step; angle+=step) {
   if (angle > 270.0) { angle = 270.0; }
   
   x1 = float(w1) * cos(angle * M_PI_DIV_180)+CX;
   y1 = float(h1) * sin(angle * M_PI_DIV_180)+CY;
   X1 = float(W1) * cos(angle * M_PI_DIV_180)+CX;
   Y1 = float(H1) * sin(angle * M_PI_DIV_180)+CY;
   
   if (angle == -90.0) { lx1 = x1; ly1 = y1; lX1 = X1; lY1 = Y1; }
   
   fl_vertex(double(lX1), double(lY1));fl_vertex(double(X1), double(Y1));
   fl_vertex(double(X1), double(Y1+heightE));fl_vertex(double(lX1), double(lY1+heightE));
   
   fl_vertex(double(lx1), double(ly1));fl_vertex(double(x1), double(y1));
   fl_vertex(double(x1), double(y1+heightE));fl_vertex(double(lx1), double(ly1+heightE));
   
   lx1=x1;ly1=y1; lX1 = X1; lY1 = Y1;
   if (angle >= 270.0) { angle = 270.0+step; }
  }
  fl_end_points();
  
  return;
 }
 
 
 // calculation angles for each slice 
 {
  double sum_v = 0.0; // sum all values
  for (int _i = 0; _i < sz_; _i++) { sum_v += val_[_i]; }
  double one_v = sum_v/100.0;
  
  if (sz_ > 1) {
  for (int _i = 0; _i < sz_; _i++) {
   float result_v = float(val_[_i]/one_v*3.6);
   start_angle[_i] = offset_angle;
   end_angle[_i] = start_angle[_i]+result_v;
   offset_angle += result_v;
   if (detach_[_i]) {
    if (_i == 0) { end_angle[_i] -= 5.0; }
    else {
     if (!detach_[_i-1]) { start_angle[_i] += 5.0; }
     end_angle[_i] -= 5.0;
    }
    heightE += 5; CY -= 5;
   }
   //printf("start_angle[_i]: %f; end_angle[_i]: %f\n", start_angle[_i], end_angle[_i]);
  }
 } else { start_angle[0] = -90.0; end_angle[0] = 270.0; }
  
 }
 
 
 
 // draw slices from end of queue
 for (int I = sz_, txt_x = x(), txt_y = y()+H1; I--; ) {
  
  if (detach_[I] && I == 0) { heightE -= 5; CY += 5; }
  
  col_sides=fl_color_average(col_[I], FL_BLACK, 0.92);
  col_iring=fl_color_average(col_[I], FL_BLACK, 0.9);
  col_ering=fl_color_average(col_[I], FL_BLACK, 0.95);
  col_top=col_[I];
  col_border=fl_color_average(col_[I], FL_BLACK, 0.94);
  
  if (!active_r()) {
   col_sides = fl_inactive(col_sides);
   col_iring = fl_inactive(col_iring);
   col_ering = fl_inactive(col_ering);
   col_top = fl_inactive(col_top);
   col_border = fl_inactive(col_border);
  }
  
  
  float rstart = start_angle[I], rend = end_angle[I];
  if (rstart > 270.0) { rstart = 270.0-rstart; }
  if (rend > 270.0) { rend = 270.0-rend; }
  bool rside = (rstart >= 90.0 && rstart <= 270.0);
  bool lside = (rend >= -90.0 && rend <= 90.0);
  bool iring = ( ((rstart >= -90.0 && rstart <= 0.0) || (rstart >= 180.0 && rstart <= 270.0)) ||
  ((rend >= -90.0 && rend <= 0.0) || (rend >= 180.0 && rend <= 270.0)) );
  bool ering = ((rstart >= 0.0 && rstart <= 180.0) || (rend >= 0.0 && rend <= 180.0));
  
  if (!ering && sz_ == 1) { ering = true; }
  
  if (rside) {
   int rindex;
   if (I==0) { rindex = sz_-1; }
   else { rindex = I-1; }
   if (!detach_[I] && !detach_[rindex]) { rside = false; }
  }
  
  if (lside) {
   int rindex;
   if (I==sz_-1) { rindex = 0; }
   else { rindex = I+1; }
   if (!detach_[I] && !detach_[rindex]) { lside = false; }
  }
  
  
  
  // vertices for Big arc
  X1 = float(W1) * cos(start_angle[I] * M_PI_DIV_180)+CX; Y1 = float(H1) * sin(start_angle[I] * M_PI_DIV_180)+CY;
  // vertices for Small arc
  x1 = float(w1) * cos(start_angle[I] * M_PI_DIV_180)+CX; y1 = float(h1) * sin(start_angle[I] * M_PI_DIV_180)+CY;
  sx=x1;sy=y1;Sx=X1;Sy=Y1;
  
  // vertices for Big arc
  X1 = float(W1) * cos(end_angle[I] * M_PI_DIV_180)+CX; Y1 = float(H1) * sin(end_angle[I] * M_PI_DIV_180)+CY;
  // vertices for Small arc
  x1 = float(w1) * cos(end_angle[I] * M_PI_DIV_180)+CX; y1 = float(h1) * sin(end_angle[I] * M_PI_DIV_180)+CY;
  Ex=X1;Ey=Y1;ex=x1;ey=y1;
  
  
  if (rside) {
   //printf("coloring right(start) side ...\n");
   fl_color(col_sides);
   fl_begin_polygon();
   fl_vertex(double(sx), double(sy));fl_vertex(double(Sx), double(Sy));
   fl_vertex(double(Sx), double(Sy+heightE));fl_vertex(double(sx), double(sy+heightE));
   fl_end_polygon();
   
   fl_color(col_border);
   fl_begin_line();
   fl_vertex(double(sx), double(sy));fl_vertex(double(sx), double(sy+heightE)); fl_gap();
   fl_vertex(double(sx), double(sy+heightE));fl_vertex(double(Sx), double(Sy+heightE)); fl_gap();
   fl_vertex(double(Sx), double(Sy));fl_vertex(double(Sx), double(Sy+heightE)); fl_gap();
   fl_end_line();
  }
  
  
  if (lside) {
   //printf("coloring left(end) side ...\n");
   fl_color(col_sides);
   fl_begin_polygon();
   fl_vertex(double(ex), double(ey));fl_vertex(double(Ex), double(Ey));
   fl_vertex(double(Ex), double(Ey+heightE));fl_vertex(double(ex), double(ey+heightE));
   fl_end_polygon();
   
   fl_color(col_border);
   fl_begin_line();
   fl_vertex(double(ex), double(ey));fl_vertex(double(ex), double(ey+heightE)); fl_gap();
   fl_vertex(double(ex), double(ey+heightE));fl_vertex(double(Ex), double(Ey+heightE)); fl_gap();
   fl_vertex(double(Ex), double(Ey));fl_vertex(double(Ex), double(Ey+heightE)); fl_gap();
   fl_end_line();
  }
  
  
  
  if (iring) {
   //printf("coloring internal ring ...\n");
   fl_color(col_iring);
   lx1=0.0;ly1=0.0;
   for (float angle=start_angle[I]; angle < end_angle[I]+step; angle+=step) {
    if (angle > end_angle[I]) { angle = end_angle[I]; }
    x1 = float(w1) * cos(angle * M_PI_DIV_180)+CX;
    y1 = float(h1) * sin(angle * M_PI_DIV_180)+CY;
    if(angle == start_angle[I]){ lx1 = x1; ly1 = y1; }
    if ((angle >= 180.0 && angle <= 360.0) || (angle >= -90.0 && angle <= 0.0)) {
     fl_color(col_iring);
     fl_begin_polygon();
     fl_vertex(double(lx1), double(ly1));fl_vertex(double(x1), double(y1));
     fl_vertex(double(x1), double(y1+heightE));fl_vertex(double(lx1), double(ly1+heightE));
     fl_end_polygon();
     
     fl_color(col_border);
     fl_begin_line();
     fl_vertex(double(lx1), double(ly1+heightE));fl_vertex(double(x1), double(y1+heightE)); fl_gap();
     fl_end_line();
    }
    lx1=x1;ly1=y1;
    if (angle >= end_angle[I]) { angle = end_angle[I]+step; }
   }
   
   fl_color(col_border);
   fl_begin_line();
   fl_vertex(double(sx), double(sy));fl_vertex(double(sx), double(sy+heightE)); fl_gap();
   fl_vertex(double(ex), double(ey));fl_vertex(double(ex), double(ey+heightE)); fl_gap();
   fl_end_line();
  }
  
  
  
  if (ering) {
   //printf("coloring external ring ...\n");
   fl_color(col_ering);
   lX1=0.0;lY1=0.0;
   for (float angle=start_angle[I]; angle < end_angle[I]+step; angle+=step) {
    if (angle > end_angle[I]) { angle = end_angle[I]; }
     X1 = float(W1) * cos(angle * M_PI_DIV_180)+CX;
     Y1 = float(H1) * sin(angle * M_PI_DIV_180)+CY;
     if (angle == start_angle[I]) { lX1 = X1; lY1 = Y1; }
    if (angle >= 0.0 && angle <= 180.0) {
     fl_color(col_ering);
     fl_begin_polygon();
     fl_vertex(double(lX1), double(lY1));fl_vertex(double(X1), double(Y1));
     fl_vertex(double(X1), double(Y1+heightE));fl_vertex(double(lX1), double(lY1+heightE));
     fl_end_polygon();
     
     fl_color(col_border);
     fl_begin_line();
     fl_vertex(double(lX1), double(lY1+heightE));fl_vertex(double(X1), double(Y1+heightE)); fl_gap();
     fl_end_line();
    }
    lX1=X1;lY1=Y1;
    if (angle >= end_angle[I]) { angle = end_angle[I]+step; }
   }
   
   fl_color(col_border);
   fl_begin_line();
   fl_vertex(double(Sx), double(Sy));fl_vertex(double(Sx), double(Sy+heightE)); fl_gap();
   if ((rend >= -90.0 && rend <=180.0) || (end_angle[I] > 270.0 && (270.0-end_angle[I]) <= 180.0 )) {
    fl_vertex(double(Ex), double(Ey));fl_vertex(double(Ex), double(Ey+heightE)); fl_gap();
   }
   fl_end_line();
  }
  
  
  
  //printf("coloring top area ...\n");
  fl_color(col_top);
  lX1=0.0;lY1=0.0; lx1=0.0;ly1=0.0;
  
  for (float angle=start_angle[I]; angle < end_angle[I]+step; angle+=step) {
   if (angle > end_angle[I]) { angle = end_angle[I]; }
   X1 = float(W1) * cos(angle * M_PI_DIV_180)+CX;
   Y1 = float(H1) * sin(angle * M_PI_DIV_180)+CY;
   x1 = float(w1) * cos(angle * M_PI_DIV_180)+CX;
   y1 = float(h1) * sin(angle * M_PI_DIV_180)+CY;
   if (angle == start_angle[I]) { lX1 = X1; lY1 = Y1; lx1 = x1; ly1 = y1; }
   fl_color(col_top);
   fl_begin_polygon();
   fl_vertex(double(lx1), double(ly1));fl_vertex(double(x1), double(y1));
   fl_vertex(double(X1), double(Y1));fl_vertex(double(lX1), double(lY1));
   fl_end_polygon();
   
   fl_color(col_border);
   fl_begin_line();
   fl_vertex(double(lx1), double(ly1));fl_vertex(double(x1), double(y1)); fl_gap();
   fl_vertex(double(lX1), double(lY1));fl_vertex(double(X1), double(Y1)); fl_gap();
   fl_end_line();
   
   lX1=X1;lY1=Y1; lx1=x1;ly1=y1;
   if (angle >= end_angle[I]) { angle = end_angle[I]+step; }
  }
  
  
  fl_color(col_border);
  fl_begin_line();
  fl_vertex(double(sx), double(sy));fl_vertex(double(Sx), double(Sy)); fl_gap();
  fl_vertex(double(ex), double(ey));fl_vertex(double(Ex), double(Ey)); fl_gap();
  fl_end_line();
  
  
  if (I == sz_-1) { txt_x = x()+w(); }
  
  
  // draw labels
  if (*txt_[I] && (end_angle[I]-start_angle[I]) > 0.0) {
   //calc center of polygon
   txt_x = (Sx+Ex+sx+ex) / 4;
   txt_y = (Sy+Ey+sy+ey) / 4;
   
   if (start_angle[I] <= 0.0 && end_angle[I] <= 180.0) { txt_x += w1*2; }
   
//    Fl_Label l;
//    l.value=txt_[I];
//    l.image=0;
//    l.deimage=0;
//    l.font=labelfont();
//    l.size=labelsize();
//    l.color=col_iring;
//    l.align_=FL_ALIGN_LEFT|FL_ALIGN_WRAP|FL_ALIGN_INSIDE;
//    l.type=0;
//    l.draw(txt_x, CY-H1-fl_height()*(I-sz_/2), 200, labelsize(), l.align_);
   
   fl_font(labelfont(), labelsize());
   if (I > sz_/2) {
    fl_color(active_r() ? labelcolor() : fl_inactive(labelcolor()));
    fl_line(txt_x, CY-H1-fl_height()*(I-sz_/2), txt_x, txt_y);
    fl_color(col_iring);
    fl_draw(txt_[I], txt_x, CY-H1-fl_height()*(I-sz_/2));
   }
   else {
    fl_color(active_r() ? labelcolor() : fl_inactive(labelcolor()));
    fl_line(txt_x, CY+H1+fl_height()+fl_height()*I+heightE-fl_height(), txt_x, txt_y);
    fl_color(col_iring);
    fl_draw(txt_[I], txt_x, CY+H1+fl_height()+fl_height()*I+heightE);
   }
  }
  
  if (detach_[I] && I != 0) { heightE -= 5; CY += 5; }
  
 } // main loop drawing slices ...
 
 
 
 
 LABEL_EXIT:
 
 
 delete[] start_angle; start_angle=0;
 delete[] end_angle; end_angle=0;
 
 
 draw_label();
 
 fl_pop_clip();
 
 ///printf("spent time: %f\n", GetTimeSec()-start_draw);
 
}



#endif // Fl_Chart3d_cxx
